#ifndef __DIRLIST_H__
#define __DIRLIST_H__

class BBitmap;
class BDirectory;

#include "ListViewer.h"

// The field identifiers for columns
#define FIELD_DIRECTORY			'dirn'	// The name of the directory

// The MIME types in BeOS to find system icons
#define MIME_ROOT				"application/x-vnd.Be-root"
#define MIME_VOLUME				"application/x-vnd.Be-volume"
#define MIME_FOLDER				"application/x-vnd.Be-directory"

class CDirectoryRow : public CRow
{
public:
	CDirectoryRow(CColumnListView *view,const char *path);
	~CDirectoryRow();
	
	virtual bool DrawIcon(BView *targetView,BRect rect,float *width);
	virtual bool IsExpandable(void);
	virtual void ExpandOperation(bool bExpanding);
	virtual void ExpandOperationComplete(bool bExpanding);
	
	void GetPath(char *buffer);	// Get the path pointed to by this row
	void GetName(char *buffer);	// Get the name of this directory alone
protected:
	BBitmap *icon;			// Either a 'drive' icon or a 'folder' icon
	char *directory;		// The directory this object represents
	CColumnListView *lview;	// The actual Column List View to operate on
private:
	static void GetLeafName(const char *in_buf,char *out_buf);
	static bool UsableDirectory(const char *in_dir);
	
//	static BBitmap* GetIconType(const char *mime_type);
//	static const char* FindIconType(const char *directory);
//	static BBitmap* AttemptLoadNodeIcon(const char *directory);
	static BBitmap* FindNodeIcon(const char *directory);

	bool bIsExpandable;
};

#endif // __DIRLIST_H__
