#include <stdio.h>
#include <Application.h>
#include "QuickWindow.h"

#include "ListViewer.h"
#include "ListViewerTypes.h"

char *word[]={
	"Seven",
	"Electic",
	"Pikachu",
	"Attacks",
};

CColumnListView *list;

CQuickWindow::CQuickWindow(BRect frame)
:BWindow(frame,"Quick Application",B_TITLED_WINDOW,0)
{
//	CColumnListView *list;
	CRow *row,*newrow;

	AddChild(list=new CColumnListView(Bounds(),"columns",B_FOLLOW_ALL_SIDES,0,LISTMODE_MULTI));
	
	datecount=0;
	list->SetSorting(true);
	
	// Add columns
	list->AddColumn(new CStringColumn("String",150,5,1000),'STRN',"Strings",0);
	list->AddColumn(new CIntColumn("Integer",70,5,1000),'INTG',"Integers",1);
	list->AddColumn(new CStringColumn("Date",80,5,1000),'DATE',"Date",2);
	
	// Add rows
	row=new CRow;
	row->AddField(new CStringField("String field"),'STRN');
	list->AddRow(row);
	
	row=new CRow;
	row->AddField(new CIntField(0),'INTG');
	list->AddRow(row);
	
	row=new CRow;
	row->AddField(new CStringField("Date field"),'DATE');
	list->AddRow(row);

	row=new CRow;
	row->AddField(new CStringField("Text Row"),'STRN');
	row->AddField(new CIntField(1),'INTG');
	row->AddField(new CStringField("3rd September 2000"),'DATE');
	list->AddRow(row);
	
	row=new CRow;
	row->AddField(new CStringField("New Column List View"),'STRN');
	row->AddField(new CIntField(19),'INTG');
	row->AddField(new CStringField("3rd September 2000"),'DATE');
	list->AddRow(row);
	
	newrow=new CRow;
	newrow->AddField(new CStringField("A heirarchical row"),'STRN');
	newrow->AddField(new CIntField(17),'INTG');
	newrow->AddField(new CStringField("3rd September 2000"),'DATE');
	list->AddRow(newrow,row);

	AddHeirarchy(list,NULL,4);
}
void CQuickWindow::AddHeirarchy(CColumnListView *list,CRow *row,int count)
{
	int pos;
	CRow *newrow;
	char bob[100];

	if(row==NULL) {
		newrow=new CRow;
		newrow->AddField(new CStringField("Test heirarchy root row"),'STRN');
		newrow->AddField(new CIntField(0),'INTG');
		newrow->AddField(new CStringField("Today"),'DATE');
		list->AddRow(newrow);
		AddHeirarchy(list,newrow,count);
	} else {
		for(pos=0;pos<count;pos++) {
			newrow=new CRow;
			newrow->AddField(new CStringField(word[datecount%4]),'STRN');
			newrow->AddField(new CIntField(pos+datecount),'INTG');
			sprintf(bob,"%i",datecount);
			datecount++;
			newrow->AddField(new CStringField(bob),'DATE');
			list->AddRow(newrow,row);
			AddHeirarchy(list,newrow,count-(pos+1));
		}
	}
}
CQuickWindow::~CQuickWindow()
{
}

bool CQuickWindow::QuitRequested(void)
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return true;
}
